package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.QualificationAttribute;
import de.humance.eco.profile.model.QualificationAttributeModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the QualificationAttribute service. Represents a row in the &quot;Profile_QualificationAttribute&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.QualificationAttributeModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link QualificationAttributeImpl}.
 * </p>
 *
 * @author Humance
 * @see QualificationAttributeImpl
 * @see de.humance.eco.profile.model.QualificationAttribute
 * @see de.humance.eco.profile.model.QualificationAttributeModel
 * @generated
 */
public class QualificationAttributeModelImpl extends BaseModelImpl<QualificationAttribute>
    implements QualificationAttributeModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a qualification attribute model instance should use the {@link de.humance.eco.profile.model.QualificationAttribute} interface instead.
     */
    public static final String TABLE_NAME = "Profile_QualificationAttribute";
    public static final Object[][] TABLE_COLUMNS = {
            { "qualificationAttributeId", Types.BIGINT },
            { "qualificationId", Types.BIGINT },
            { "qualificationAttributeDefinitionId", Types.BIGINT },
            { "type_", Types.VARCHAR },
            { "sequenceNumber", Types.BIGINT },
            { "attributeValue", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_QualificationAttribute (qualificationAttributeId LONG not null primary key,qualificationId LONG,qualificationAttributeDefinitionId LONG,type_ VARCHAR(75) null,sequenceNumber LONG,attributeValue TEXT null)";
    public static final String TABLE_SQL_DROP = "drop table Profile_QualificationAttribute";
    public static final String ORDER_BY_JPQL = " ORDER BY qualificationAttribute.qualificationId ASC, qualificationAttribute.sequenceNumber ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_QualificationAttribute.qualificationId ASC, Profile_QualificationAttribute.sequenceNumber ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.QualificationAttribute"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.QualificationAttribute"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.QualificationAttribute"),
            true);
    public static long QUALIFICATIONATTRIBUTEDEFINITIONID_COLUMN_BITMASK = 1L;
    public static long QUALIFICATIONID_COLUMN_BITMASK = 2L;
    public static long SEQUENCENUMBER_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.QualificationAttribute"));
    private static ClassLoader _classLoader = QualificationAttribute.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            QualificationAttribute.class
        };
    private long _qualificationAttributeId;
    private long _qualificationId;
    private long _originalQualificationId;
    private boolean _setOriginalQualificationId;
    private long _qualificationAttributeDefinitionId;
    private long _originalQualificationAttributeDefinitionId;
    private boolean _setOriginalQualificationAttributeDefinitionId;
    private String _type;
    private long _sequenceNumber;
    private String _attributeValue;
    private long _columnBitmask;
    private QualificationAttribute _escapedModel;

    public QualificationAttributeModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _qualificationAttributeId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setQualificationAttributeId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _qualificationAttributeId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return QualificationAttribute.class;
    }

    @Override
    public String getModelClassName() {
        return QualificationAttribute.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("qualificationAttributeId", getQualificationAttributeId());
        attributes.put("qualificationId", getQualificationId());
        attributes.put("qualificationAttributeDefinitionId",
            getQualificationAttributeDefinitionId());
        attributes.put("type", getType());
        attributes.put("sequenceNumber", getSequenceNumber());
        attributes.put("attributeValue", getAttributeValue());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long qualificationAttributeId = (Long) attributes.get(
                "qualificationAttributeId");

        if (qualificationAttributeId != null) {
            setQualificationAttributeId(qualificationAttributeId);
        }

        Long qualificationId = (Long) attributes.get("qualificationId");

        if (qualificationId != null) {
            setQualificationId(qualificationId);
        }

        Long qualificationAttributeDefinitionId = (Long) attributes.get(
                "qualificationAttributeDefinitionId");

        if (qualificationAttributeDefinitionId != null) {
            setQualificationAttributeDefinitionId(qualificationAttributeDefinitionId);
        }

        String type = (String) attributes.get("type");

        if (type != null) {
            setType(type);
        }

        Long sequenceNumber = (Long) attributes.get("sequenceNumber");

        if (sequenceNumber != null) {
            setSequenceNumber(sequenceNumber);
        }

        String attributeValue = (String) attributes.get("attributeValue");

        if (attributeValue != null) {
            setAttributeValue(attributeValue);
        }
    }

    @Override
    public long getQualificationAttributeId() {
        return _qualificationAttributeId;
    }

    @Override
    public void setQualificationAttributeId(long qualificationAttributeId) {
        _qualificationAttributeId = qualificationAttributeId;
    }

    @Override
    public long getQualificationId() {
        return _qualificationId;
    }

    @Override
    public void setQualificationId(long qualificationId) {
        _columnBitmask = -1L;

        if (!_setOriginalQualificationId) {
            _setOriginalQualificationId = true;

            _originalQualificationId = _qualificationId;
        }

        _qualificationId = qualificationId;
    }

    public long getOriginalQualificationId() {
        return _originalQualificationId;
    }

    @Override
    public long getQualificationAttributeDefinitionId() {
        return _qualificationAttributeDefinitionId;
    }

    @Override
    public void setQualificationAttributeDefinitionId(
        long qualificationAttributeDefinitionId) {
        _columnBitmask |= QUALIFICATIONATTRIBUTEDEFINITIONID_COLUMN_BITMASK;

        if (!_setOriginalQualificationAttributeDefinitionId) {
            _setOriginalQualificationAttributeDefinitionId = true;

            _originalQualificationAttributeDefinitionId = _qualificationAttributeDefinitionId;
        }

        _qualificationAttributeDefinitionId = qualificationAttributeDefinitionId;
    }

    public long getOriginalQualificationAttributeDefinitionId() {
        return _originalQualificationAttributeDefinitionId;
    }

    @Override
    public String getType() {
        if (_type == null) {
            return StringPool.BLANK;
        } else {
            return _type;
        }
    }

    @Override
    public void setType(String type) {
        _type = type;
    }

    @Override
    public long getSequenceNumber() {
        return _sequenceNumber;
    }

    @Override
    public void setSequenceNumber(long sequenceNumber) {
        _columnBitmask = -1L;

        _sequenceNumber = sequenceNumber;
    }

    @Override
    public String getAttributeValue() {
        if (_attributeValue == null) {
            return StringPool.BLANK;
        } else {
            return _attributeValue;
        }
    }

    @Override
    public void setAttributeValue(String attributeValue) {
        _attributeValue = attributeValue;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            QualificationAttribute.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public QualificationAttribute toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (QualificationAttribute) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        QualificationAttributeImpl qualificationAttributeImpl = new QualificationAttributeImpl();

        qualificationAttributeImpl.setQualificationAttributeId(getQualificationAttributeId());
        qualificationAttributeImpl.setQualificationId(getQualificationId());
        qualificationAttributeImpl.setQualificationAttributeDefinitionId(getQualificationAttributeDefinitionId());
        qualificationAttributeImpl.setType(getType());
        qualificationAttributeImpl.setSequenceNumber(getSequenceNumber());
        qualificationAttributeImpl.setAttributeValue(getAttributeValue());

        qualificationAttributeImpl.resetOriginalValues();

        return qualificationAttributeImpl;
    }

    @Override
    public int compareTo(QualificationAttribute qualificationAttribute) {
        int value = 0;

        if (getQualificationId() < qualificationAttribute.getQualificationId()) {
            value = -1;
        } else if (getQualificationId() > qualificationAttribute.getQualificationId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        if (getSequenceNumber() < qualificationAttribute.getSequenceNumber()) {
            value = -1;
        } else if (getSequenceNumber() > qualificationAttribute.getSequenceNumber()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof QualificationAttribute)) {
            return false;
        }

        QualificationAttribute qualificationAttribute = (QualificationAttribute) obj;

        long primaryKey = qualificationAttribute.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        QualificationAttributeModelImpl qualificationAttributeModelImpl = this;

        qualificationAttributeModelImpl._originalQualificationId = qualificationAttributeModelImpl._qualificationId;

        qualificationAttributeModelImpl._setOriginalQualificationId = false;

        qualificationAttributeModelImpl._originalQualificationAttributeDefinitionId = qualificationAttributeModelImpl._qualificationAttributeDefinitionId;

        qualificationAttributeModelImpl._setOriginalQualificationAttributeDefinitionId = false;

        qualificationAttributeModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<QualificationAttribute> toCacheModel() {
        QualificationAttributeCacheModel qualificationAttributeCacheModel = new QualificationAttributeCacheModel();

        qualificationAttributeCacheModel.qualificationAttributeId = getQualificationAttributeId();

        qualificationAttributeCacheModel.qualificationId = getQualificationId();

        qualificationAttributeCacheModel.qualificationAttributeDefinitionId = getQualificationAttributeDefinitionId();

        qualificationAttributeCacheModel.type = getType();

        String type = qualificationAttributeCacheModel.type;

        if ((type != null) && (type.length() == 0)) {
            qualificationAttributeCacheModel.type = null;
        }

        qualificationAttributeCacheModel.sequenceNumber = getSequenceNumber();

        qualificationAttributeCacheModel.attributeValue = getAttributeValue();

        String attributeValue = qualificationAttributeCacheModel.attributeValue;

        if ((attributeValue != null) && (attributeValue.length() == 0)) {
            qualificationAttributeCacheModel.attributeValue = null;
        }

        return qualificationAttributeCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(13);

        sb.append("{qualificationAttributeId=");
        sb.append(getQualificationAttributeId());
        sb.append(", qualificationId=");
        sb.append(getQualificationId());
        sb.append(", qualificationAttributeDefinitionId=");
        sb.append(getQualificationAttributeDefinitionId());
        sb.append(", type=");
        sb.append(getType());
        sb.append(", sequenceNumber=");
        sb.append(getSequenceNumber());
        sb.append(", attributeValue=");
        sb.append(getAttributeValue());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(22);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.QualificationAttribute");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>qualificationAttributeId</column-name><column-value><![CDATA[");
        sb.append(getQualificationAttributeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>qualificationId</column-name><column-value><![CDATA[");
        sb.append(getQualificationId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>qualificationAttributeDefinitionId</column-name><column-value><![CDATA[");
        sb.append(getQualificationAttributeDefinitionId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>type</column-name><column-value><![CDATA[");
        sb.append(getType());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>sequenceNumber</column-name><column-value><![CDATA[");
        sb.append(getSequenceNumber());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>attributeValue</column-name><column-value><![CDATA[");
        sb.append(getAttributeValue());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
